
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android安全开发之浅谈密钥硬编码 / 憋错料</title>

    <meta name="description" content="Android安全开发之浅谈密钥硬编码 Android安全开发之浅谈密钥硬编码 作者:伊樵.呆狐@阿里聚安全 1 简介 在阿里聚安全的漏洞扫描器中和人工APP安全审计中,经常发现有开发者将密钥硬编码在Java代码.文件中,这样做会引起很大风险.信息安全的基础在于密码学,而常用的密码学算法都是公开的,加密内容的保密依靠的是密钥的保密,密钥如果泄露,对于对称密码算法,根据用到的密钥算法和加密后的密文,很容易得到加密前的明文:对于非对称密码算法或者签名算法,根据密钥和要加密的明文,很容易获得计算出签名值,从而伪造签名. 2 风险案例 密钥硬">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android安全开发之浅谈密钥硬编码</h1>
    	<section>
		<article class="clearfix">
		<h2>Android安全开发之浅谈密钥硬编码</h2>
<p>作者：伊樵、呆狐@阿里聚安全</p>
<h2>1 简介</h2>
<p>在阿里聚安全的漏洞扫描器中和人工APP安全审计中，经常发现有开发者将密钥硬编码在Java代码、文件中，这样做会引起很大风险。<strong>信息安全的基础在于密码学，而常用的密码学算法都是公开的</strong>，加密内容的保密依靠的是密钥的保密，密钥如果泄露，对于<strong>对称密码算法</strong>，根据用到的密钥算法和加密后的密文，很容易得到加密前的明文；对于<strong>非对称密码算法或者签名算法</strong>，根据密钥和要加密的明文，很容易获得计算出签名&#20540;，从而伪造签名。</p>
<h2>2 风险案例</h2>
<p>密钥硬编码在代码中，而根据密钥的用途不同，这导致了不同的安全风险，有的导致加密数据被破解，数据不再保密，有的导致和服务器通信的加签被破解，引发各种血案，以下借用乌云上已公布的几个APP漏洞来讲讲。</p>
<h3>2.1 某互联网金融APP加密算法被破解导致敏感信息泄露</h3>
<p>某P2P应用客户端，用来加密数据的DES算法的密钥硬编码在Java代码中，而DES算法是对称密码算法，既加密密钥和解密密钥相同。</p>
<p>反编译APP，发现DES算法：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRjZnJtMTYwLnBuZw==.jpg"></p>
<p>发现DES算法的密钥，硬编码为“yrdAppKe”，用来加密手势密码：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRkZGZsY3UwLnBuZw==.jpg"></p>
<p>将手势密码用DES加密后存放在本地LocusPassWordView.xml文件中：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRlOXVrZ28wLnBuZw==.jpg"></p>
<p>知道了密文和加密算法以及密钥，通过解密操作，可以从文件中恢复出原始的手势密码。或者使用新的生成新的手势密码</p>
<p>而与服务器通信时接口中的Jason字段也用了DES算法和密钥硬编码为“yRdappKY”：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRmN25kbjkwLnBuZw==.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRnNGJycG4wLnBuZw==.jpg"></p>
<p>和服务器通信采用http传输，没有使用https来加密通信，如果采用中间人攻击或者路由器镜像，获得流量数据，可以破解出用户的通信内容。</p>
<h3>2.2 某租车APP加密算法被破解导致一些列风险</h3>
<p>某租车APP与服务器通信的接口采用http传输数据，并且有对传输的部分参数进行了加密，加密算法采用AES，但是密钥硬编码在java代码中为“shenzhoucar123123”，可被逆向分析出来，导致伪造请求，结合服务器端的漏洞，引起越权访问的风险，如越权查看其它用户的订单等。</p>
<p>和服务器通信时的数据为：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDR0bjVlOHEwLkpQRw==.jpg"></p>
<p>q字段是加密后的内容。逆向APP，从登录Activity入手：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRoODVpaG4wLnBuZw==.jpg"></p>
<p>分析登录流程：v1是用户名，v2是密码，v3是PushId，在用户名和密码不为空并且长度不小于11情况下，执行LoginOperate相关操作，追踪LoginOperate的实现，发现继承自BaseOperate，继续追踪BaseOperate的实现：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRpMWVxZXMwLnBuZw==.jpg"></p>
<p>在BaseOperate的initUrl()方法中，找到了APP是怎么生成请求数据的：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRpcG4zbWYwLnBuZw==.jpg"></p>
<p>继续追踪上图中的initJsonUrl()方法，发现其调用了AES加密：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRqbzFoMDkwLmpwZw==.jpg"></p>
<p>继续追踪aes.onEncrypt()函数：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRrZDB0ZnEwLnBuZw==.jpg"></p>
<p>在onEncrypt()函数中调用了encrypt()函数用来加密数据，追踪encrypt()函数的实现，发现其使用AES算法，并且密钥硬编码在java代码中为“shenzhoucar123123”</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRsMmlkY28wLnBuZw==.jpg"></p>
<p>到现在请求中的数据加密如何实现的就清晰了，另外由于服务器权限控制不严，就可以构造订单id的请求，达到越权访问到其他用户的订单。</p>
<p>构造{“id”:”11468061”}的请求:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDR2bTNvN3IwLkpQRw==.jpg"></p>
<p>其中uid设置为你自己的uid即可，可以成功看到其他人的订单:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRsdjFpMTcwLnBuZw==.jpg"></p>
<p>攻击者完全可以做到使用其他脚本重新实现相同的加密功能并拼接出各个接口请求，批量的刷取订单信息和用户其他信息。</p>
<h3>2.3 某酒店APP加签算法被破解导致一系列风险</h3>
<p>某酒店APP和服务器通信时接口采用http通信，数据进行了加密，并且对传输参数进行签名，在服务器端校验签名，以检查传输的数据是否被篡改，但是加签算法和密钥被逆向分析，可导致加签机制失效，攻击者可任意伪造请求包，若结合服务器端的权限控制有漏洞，则可引发越权风险等。</p>
<p>APP和服务器通信的原始包如下图，可以看到有加签字段sign：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRwMmkwMmQwLnBuZw==.jpg"></p>
<p>逆向APP定位到加密算法的逻辑代码，com.htinns.biz.HttpUtils.class，其实现逻辑为：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRxM2JrMWowLnBuZw==.jpg"></p>
<p>原始数据是unSignData，使用RC4算法加密，密钥为KEY变量所代表的&#20540;，加密后的数据为signData，传输的数据时的data字段为signData。</p>
<p>加签字段signd的生成方法是用unsignData拼接时间戳time和resultkey，然后做md5，再进行base64编码。时间戳保证了每次请求包都不一样。</p>
<p>sendSign()算法是用c或c&#043;&#043;写的，放入了so库，其他重要算法都是用java写的。</p>
<p>可以使用IDA逆向分析so库，找到sendSign()方法</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZXBvLmFsaWNkbi5jb20vaW1hZ2UvNDF2NDRyMzU1OWEwLnBuZw==.jpg"></p>
<p>而乌云漏洞提交者采用的是分析sign和getSign(sign)的数据，做一个算法破解字典。其实还有种方法直接调用此so库，来生成字典。</p>
<p>签名破解以后，就可以构造发送给服务器的数据包进行其他方面的安全测试，比如越权、重置密码等。</p>
<h2>3 阿里聚安全开发建议</h2>
<p>通过以上案例，并总结下自己平时发现密钥硬编码的<strong>主要形式</strong>有：</p>
<p>1、密钥直接明文存在sharedprefs文件中，这是最不安全的。</p>
<p>2、密钥直接硬编码在Java代码中，这很不安全，dex文件很容易被逆向成java代码。</p>
<p>3、将密钥分成不同的几段，有的存储在文件中、有的存储在代码中，最后将他们拼接起来，可以将整个操作写的很复杂，这因为还是在java层，逆向者只要花点时间，也很容易被逆向。</p>
<p>4、用ndk开发，将密钥放在so文件，加密解密操作都在so文件里，这从一定程度上提高了的安全性，挡住了一些逆向者，但是有经验的逆向者还是会使用IDA破解的。</p>
<p>5、在so文件中不存储密钥，so文件中对密钥进行加解密操作，将密钥加密后的密钥命名为其他普通文件，存放在assets目录下或者其他目录下，接着在so文件里面添加无关代码（花指令），虽然可以增加静态分析难度，但是可以使用动态调式的方法，追踪加密解密函数，也可以查找到密钥内容。</p>
<p>保证密钥的安全确是件难事，涉及到密钥分发，存储，失效回收，APP防反编译和防调试，还有风险评估。可以说在设备上安全存储密钥这个基本无解，只能选择增大攻击者的逆向成本，让攻击者知难而退。而要是普通开发者的话，做妥善保护密钥这些事情这需要耗费很大的心血。</p>
<p>产品设计者或者开发者要明白自己的密钥是做什么用的，重要程度怎么样，密钥被逆向出来会造成什么风险，通过评估APP应用的重要程度来选择相应的技术方案。</p>
<p>所以<strong>建议不妨试试阿里聚安全的安全加固和安全组件</strong>，其中<strong>安全组件</strong>中的安全加密功能提供了开发者密钥的安全管理与加密算法实现，保证密钥的安全性，实现安全的加解密操作；<strong>安全签名</strong>功能实现客户端请求的签名处理，保证客户端与服务端通信请求不被伪造。<strong>安全加固</strong>提升安全等级，防止应用被逆向破解。这样同时从应用层、运行层、native层提供多层次全方位立体防护，另外还有<strong>安全沙箱、白盒加密、底层加固</strong>共同保证客户端数据安全。攻防是不断变化演进的，阿里聚安全提供的服务能实时更新客户端模块，通过阿里聚安全的漏洞扫描来检测应用是否具有密钥硬编码风险，保证在攻防对抗中永远处于上风。</p>
<p>专业的事情交给专业的人来做，自己的主要精力用来做功能开发或者业务逻辑，快速打造能赢得市场的可靠产品才是王道。</p>
<h2>参考</h2>
<p>[1]&nbsp;<a href="http://www.wooyun.org/bugs/wooyun-2010-0187287" rel="external nofollow noreferrer">http://www.wooyun.org/bugs/wooyun-2010-0187287</a></p>
<p>[2]&nbsp;<a href="http://www.wooyun.org/bugs/wooyun-2010-0105766" rel="external nofollow noreferrer">http://www.wooyun.org/bugs/wooyun-2010-0105766</a></p>
<p>[3]&nbsp;<a href="http://www.wooyun.org/bugs/wooyun-2015-0162907" rel="external nofollow noreferrer">http://www.wooyun.org/bugs/wooyun-2015-0162907</a></p>
<p>[4]&nbsp;<a href="http://jaq.alibaba.com/safety?spm=a313e.7837752.1000001.1.zwCPfa" rel="external nofollow noreferrer">http://jaq.alibaba.com/safety?spm=a313e.7837752.1000001.1.zwCPfa</a></p>
<p>[5]&nbsp;<a href="https://www.zhihu.com/question/35136485/answer/84491440" rel="external nofollow noreferrer">https://www.zhihu.com/question/35136485/answer/84491440</a></p>
<p><strong>作者：伊樵、呆狐@阿里聚安全，更多安全技术文章，请访问<a href="https://jaq.alibaba.com/community/index" rel="external nofollow noreferrer">阿里聚安全博客</a></strong></p>				<div id="time"><strong>时间：</strong> 2024-03-29 23:12:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android安全开发之浅谈密钥硬编码的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBWkNj0.html" rel="bookmark">安卓开发&lowbar;浅谈Android动画（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Property动画 概念:属性动画,即通过改变对象属性的动画. 特点:属性动画真正改变了一个UI控件,包括其事件触发焦点的位置 一.重要的动画类及属性值: 1.  ValueAnimator 基本属性动画类 方法 描述 setDuration(long duration) 设置动画持续时间的方法 setEvaluator(TypeEvaluator value) 设置插值计算的类型 setInterpolator(TimeInterpolator value) 设置时间插值器的类型 addUp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoQbnk3.html" rel="bookmark">安卓开发&lowbar;浅谈ListView（自定义适配器）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ListView作为一个实际开发中使用率非常高的视图,一般的系统自带的适配器都无法满足开发中的需求,这时候就需要开发人员来自定义适配器使得ListView能够有一个不错的显示效果 有这样一个Demo ,实现图片文字混合列表 1 package com.example.work; 2 3 import java.util.ArrayList; 4 import java.util.HashMap; 5 import java.util.List; 6 7 8 import android.R.in			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JYJQP3.html" rel="bookmark">Android IPC之Messenger浅谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前写过一篇有关 IPC之AIDL浅谈的文章,详情请看Android IPC之AIDL浅谈.今天再来介绍另一种 IPC-Messenger. 一.概述. 首先看Messenger介绍, Reference to a Handler, which others can use to send messages to it. This allows for the implementation of message-based communication across processes, by c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Zeypd0.html" rel="bookmark">流媒体网站开发技术浅谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				流媒体网站开发技术浅谈(2012-02) 2012-03-02    新闻来源:武汉广电网 张方东 (黄陂区广播影视局事业技术科) 摘 要:随着有线和无线网络宽带的高速发展,人们不再满足于因特网中仅有的文字.图片等简单信息,而越来越希望看到更直观.更丰富的影视节目,流媒体网站因此应运而生.本文从流媒体概念.流媒体格式.流媒体文件制作.流媒体文件传输.流媒体文件发布及流媒体网站部署等方面对开发流媒体网站作了详细阐述. 关键词:流媒体 网站开发 部署 技术 1.概述 在网络上传输多媒体有下载和流式传			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KeAOL4.html" rel="bookmark">开发技术--浅谈文件操作与字符编码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发|浅谈文件操作与字符编码 听说Python的文件操作很容易在某一些电脑上出问题,然而罪魁祸首就是字符编码.让我们来了解一些底层的编码方式. 前言 目前所有的文章思想格式都是:知识+情感. 知识:对于所有的知识点的描述.力求不含任何的自我感情色彩. 情感:用我自己的方式,解读知识点.力求通俗易懂,完美透析知识. 正文 本文主要分为两大部分,一部分是如何使用Python进行文件操作,另一部分是聊一下字符编码的那些事.(比较绕,尽量用最最最通俗的话表述~~) 文件操作 1.文件操作方式 open(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NaWQB3.html" rel="bookmark">iOS开发&amp;gt&semi;学无止境 - 浅谈MVVM的架构设计与团队协作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				李刚按:本文是青玉伏案写的一篇文章.相信大家对MVC耳熟能详,MVVM可能听说的相对少一些,这一篇文章将会想你阐述MVVM设计,还有团队协作的经验分享.如果你也觉得不错,就分享一下吧! demo:https://github.com/lizelu/MVVM 今天写这篇文章是想达到抛砖引玉的作用,想与大家交流一下思想,相互学习,博文中有不足之处还望大家批评指正.本篇文章的内容沿袭以往博客的风格,也是以干货为主,偶尔扯扯咸蛋(哈哈~不好好工作又开始发表博客啦~). 由 于本人项目经验有限,关于架构设			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBxX2q3.html" rel="bookmark">iOS开发之浅谈MVVM的架构设计与团队协作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天写这篇博客是想达到抛砖引玉的作用,想与大家交流一下思想,相互学习,博文中有不足之处还望大家批评指正.本篇博客的内容沿袭以往博客的风格,也是以干货为主,偶尔扯扯咸蛋(哈哈~不好好工作又开始发表博客啦~). 由于本人项目经验有限,关于架构设计方面的东西理解有限,我个人对MVVM的理解主要是借鉴于之前的用过的MVC的Web框架~在学校的时候用过ThinkPHP框架,和SSH框架,都是MVC的架构模式,今天MVVM与传统的MVC可谓是极为相似,也可以说是兄弟关系,也就是一家人了. 说道架构设计和团队			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgx7lN0.html" rel="bookmark">开发技术--浅谈Python函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发|浅谈Python函数 函数在实际使用中有很多不一样的小九九,我将从最基础的函数内容,延伸出函数的高级用法.此文非科普片~~ 前言 目前所有的文章思想格式都是:知识+情感. 知识:对于所有的知识点的描述.力求不含任何的自我感情色彩. 情感:用我自己的方式,解读知识点.力求通俗易懂,完美透析知识. 正文 首先介绍函数是什么,接着走进函数,并且发现函数的高级使用方法,最后列出常用的Python的内置函数. 函数是什么? 1.函数,在代码执行的是不执行,只有在调用函数的时候才会执行. 2.函数使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JpWd90.html" rel="bookmark">开发技术--浅谈python数据类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发|浅谈python数据类型 在回顾Python基础的时候,遇到最大的问题就是内容很多,而我的目的是回顾自己之前学习的内容,进行相应的总结,所以我就不玩基础了,很多在我实际生活中使用的东西,我会在文章中提一下.并且我自己会根据这些内容进行相应的补充与扩展. 文章定位:不是科普文,是自己对于自己学习的总结. 前言 目前所有的文章思想格式都是:知识+情感. 知识:对于所有的知识点的描述.力求不含任何的自我感情色彩. 情感:用我自己的方式,解读知识点.力求通俗易懂,完美透析知识. 正文 正文的主要内			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bn9k0.html" rel="bookmark" class="title">javaoo&period;day15</a>
					<div>
						关系数据库的几种设计范式介绍1.第一范式(1NF) 在任何一个关系数据库中,第一范式(1NF)是对关系模式的基本要求,不满足第一范式(1NF)的数据库就不是关系数据库. 所谓第一范式(1NF)是指数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02veo0.html" rel="bookmark" class="title">最长公共上升子序列（codevs 2185）</a>
					<div>
						题目描述 Description 熊大妈的奶牛在小沐沐的熏陶下开始研究信息题目.小沐沐先让奶牛研究了最长上升子序列,再让他们研究了最长公共子序列,现在又让他们要研究最长公共上升子序列了. 小沐沐说,对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RB7KR0.html" rel="bookmark" class="title">第 41 章 微博系统--SVN 版本控制&lbrack;下&rsqb;</a>
					<div>
						一．SVN 自动启动 如果不手工将 SVN 在 DOS 命令行启动的话,那么在你对数据版本进行提交或更新时, 将会被拒绝.所以,我们每次在重启版本服务器时,都需要手工的启动一下 SVN 服务器. 这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJKkB4.html" rel="bookmark" class="title">Machine Learning 学习笔记 &lpar;2&rpar; &mdash;&mdash; 另一种寻找极值的方法：牛顿法</a>
					<div>
						[总目录]http://www.cnblogs.com/tbcaaa8/p/4415055.html 1. 用牛顿法解方程 牛顿法是一种求解方程的迭代算法,也可以用于方程组的求解.其思想是利用方程(尤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDrXP0.html" rel="bookmark" class="title">Binary search tree system and method</a>
					<div>
						A binary search tree is provided for efficiently organizing values for a set of items, even when val ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgXnYR0.html" rel="bookmark" class="title">网络安全-加密</a>
					<div>
						1.概念 明文:需要被加密的消息,一般是人直接可以阅读理解的内容.(plaintext) 密文:  被加密后的消息,一般是人不可直接阅读并理解的.(ciphertext) 加密:将明文转换成密文的过程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRywk4.html" rel="bookmark" class="title">2017校招常考算法题归纳&amp;amp&semi;典型题目汇总</a>
					<div>
						2017校招即将来临,我们为大家整理了2017校招的常考算法类型,以及对应的典型题目. 另附参考答案地址:http://www.jiuzhang.com/solution/ 数学 尾部的零 斐波纳契数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXgrA4.html" rel="bookmark" class="title">7个你可能不认识的CSS单位&colon;rem vh vw vmin vmax ex ch</a>
					<div>
						今儿,我就准备向大伙儿介绍一些你们之前可能很少见过CSS家伙们.他们每个都是度量的单位,类似pixel 和 em 这样的,但是很有可能你之前从来就没听过这些家伙们! rem 我们首先介绍下和我们熟悉的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDyo970.html" rel="bookmark" class="title">主从 binlog&lowbar;format 设置关系</a>
					<div>
						1. 主库是row,从库必须是row/mixed.如果是statement,主库有变更时,从库报如下错误(无论什么变更都报错,如insert/update/delete/alter等): Last_E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LrP13.html" rel="bookmark" class="title">图书馆接口设计</a>
					<div>
						任务需求:实现图书1.预定2.下单3.准备4.借书5.还书6.收藏几个相关功能接口: 一.需要的几个实体: 1.图书:本数据库中没有图书,每当预定或者收藏以及借书的时候,从数据库中看是否有,没有的话就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZ1zG0.html" rel="bookmark" class="title">告诉你应该选择 openSUSE 的五大理由</a>
					<div>
						导读 多数的的桌面 Linux 用户都会选择三种发行版本:Debian/Ubuntu.Fedora 或者 Arch Linux.但是今天,我将给出你需要使用 openSUSE 的五大理由.相比其他的  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZJXOM.html" rel="bookmark" class="title">联合使用 HTML 5、地理定位 API</a>
					<div>
						查找并跟踪位置坐标以用在各种 Web 服务中 在这个由五个部分所组成的系列的第一部分中,您将接触到移动 Web 应用程序中最流行的新技术:地理定位.高端智能手机都内置 GPS,现在您将了解 Web 服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbGXZM.html" rel="bookmark" class="title">阂蝗焦膳环敖恫舅倩纤媳弛乐睹昭</a>
					<div>
						http://i2.feixin.10086.cn/pages/104004/1342769804?retcode=0 http://i2.feixin.10086.cn/pages/101813/1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471Z510.html" rel="bookmark" class="title">探秘：磁盘可用空间被谁吃掉了？</a>
					<div>
						可疑: 分区总容量 7.2T,挂载分区后发现只有6.8T的空间可以使用,400G的空间哪里去了?  探究: 1. 文件被删除未释放磁盘空间? 通过命令 lsof |grep delete 查看确认并未 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbB1KM.html" rel="bookmark" class="title">第7章 解析HTML和XHTML</a>
					<div>
						理解基本的HTML解析 在用HTMLParser模块解析之前,一般需要定义一个子类HTMLParser.HTMLParser,并添加用来处理不同标签的函数.例子: #!/usr/bin/env pyt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWbdZ0.html" rel="bookmark" class="title">用Taurus&period;MVC 做个企业站（上）</a>
					<div>
						前言: 之前是打算写一篇文章叫:Taurus.MVC 从入门到精通,一篇完事篇! 后来转指一念,还是把教程集在这个企业站项目上吧!!! 企业站风格: 之前发过一个帮师妹写的企业站:最近花了几个夜晚帮师 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezgW53.html" rel="bookmark" class="title">Fast File System</a>
					<div>
						不扯淡了,直接来写吧,一天一共要写三篇博客,还有两篇呢. 1. 这篇博客讲什么? Fast File System(FFS)快速文件系统,基本思想已经在在上一篇博客File System Implem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6Xnjr3.html" rel="bookmark" class="title">jmeter登录之-动态参数</a>
					<div>
						jmeter登录之-动态参数 1.抓包查看提交的登录参数 发现参数authenticity_token是动态的,每次都不一样,所以回放的时候就会失败 2.提取动态变化的参数-后置处理器(相当于LR的关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49vjj1M.html" rel="bookmark" class="title">信赖域算法</a>
					<div>
						最速下降法/steepest descent,牛顿法/newton,共轭方向法/conjugate direction,共轭梯度法/conjugate gradient 及其他 拟牛顿法/Quasi- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35Pbpn0.html" rel="bookmark" class="title">Memcached启动脚本</a>
					<div>
						假设memcached安装在/home/www/memcached目录 # cd /home/www/memcached # vi start.sh start.sh内容如下: bin/memcach ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
